package com.zipcodewilmington.phonebook;

import java.util.ArrayList;
import java.util.TreeMap;

/**
 * Created by leon on 1/23/18.
 */
public class PhoneBook {
    private TreeMap<String, ArrayList<String>> phoneBook = new TreeMap<>();

    public PhoneBook() {
    }

    public boolean hasEntry(String name) {
        if (phoneBook.containsKey(name)) {
            return true;
        }
        return false;
    }

    public void add(String name, ArrayList<String> phoneNumbers) {
        phoneBook.put(name, phoneNumbers);
    }

    public int size() {
        return phoneBook.size();
    }

    public int arrayListSize() {
        for(String key : phoneBook.keySet()) {
            return phoneBook.get(key).size();
        }
        return -1;
    }

    /*
    public String lookup(String name) {
        for (String key : phoneBook.keySet()) {
            if (key.equals(name)) {
                return phoneBook.get(key);
            }
        }
        return "Name not in phone book";
    }
    */

    public ArrayList<String> getArrayListFor(String name) {
        ArrayList<String> list = new ArrayList<>();
        for(String key : phoneBook.keySet()) {
            if(key.equals(name)) {
                list = phoneBook.get(key);
            }
        }
        return list;
    }

    public void remove(String name, String phoneNumber) {
        for(String key : phoneBook.keySet()) {
            if(key.equals(name)) {
                phoneBook.get(key).remove(phoneNumber);
            }
        }
    }

    public void removeRecord(String name) {
        phoneBook.remove(name);
    }

    public String reverseLookUp(String phoneNumber) {
        String name = "";
        for (String key : phoneBook.keySet()) {
            if(phoneBook.get(key).contains(phoneNumber)) {
                name = key;
            }
        }
        return name;
    }

    public String listNamesAndNumbers() {
        String listOfContacts = "";
        for(String key : phoneBook.keySet()) {
            listOfContacts += key + " " + phoneBook.get(key) + "\n";
        }
        return listOfContacts;
    }
}
