package com.zipcodewilmington.phonebook;

import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;


/**
 * Created by leon on 1/23/18.
 */
public class PhoneBookTest {

    @Test
    public void testHasEntry() {
        // Given
        PhoneBook phoneBook = new PhoneBook();
        String name = "Caleb";
        String homeNumber = "211-111-2222";
        String cellNumber = "211-222-3333";
        ArrayList<String> phoneNumbers = new ArrayList<>();
        phoneNumbers.add(homeNumber);
        phoneNumbers.add(cellNumber);

        phoneBook.add(name, phoneNumbers);

        // When
        boolean actualOutput = phoneBook.hasEntry(name);

        // Then
        Assert.assertTrue(actualOutput);
    }

    @Test
    public void testHasEntry2() {
        // Given
        PhoneBook phoneBook = new PhoneBook();
        String name = "Caleb";
        String homeNumber = "211-111-2222";
        String cellNumber = "211-222-3333";
        ArrayList<String> phoneNumbers = new ArrayList<>();
        phoneNumbers.add(homeNumber);
        phoneNumbers.add(cellNumber);

        // When
        boolean actualOutput = phoneBook.hasEntry(name);

        // Then
        Assert.assertFalse(actualOutput);

    }

    @Test
    public void testAdd() {
        // Given
        PhoneBook phoneBook = new PhoneBook();
        String name = "Liam";
        String homeNumber = "211-111-2222";
        String cellNumber = "211-222-3333";
        ArrayList<String> phoneNumbers = new ArrayList<>();
        phoneNumbers.add(homeNumber);
        phoneNumbers.add(cellNumber);

        // When
        phoneBook.add(name, phoneNumbers);

        // Then
        Assert.assertEquals(1, phoneBook.size());
    }

    /*
    @Test
    public void testLookup() {
        // Given
        PhoneBook phoneBook = new PhoneBook();
        String expectedOutput = "211-111-2222";
        String name = "Caleb";
        phoneBook.add(name, expectedOutput);

        // When
        String actualOutput = phoneBook.lookup(name);

        // Then
        Assert.assertEquals(expectedOutput, actualOutput);
    }
    */

    @Test
    public void testGetArrayListFor() {
        // Given
        PhoneBook phoneBook = new PhoneBook();
        String name = "Caleb";
        String homeNumber = "211-111-2222";
        String cellNumber = "211-222-3333";
        ArrayList<String> expectedOutput = new ArrayList<>();
        expectedOutput.add(homeNumber);
        expectedOutput.add(cellNumber);

        phoneBook.add(name, expectedOutput);

        // When
        ArrayList<String> actualOutput = phoneBook.getArrayListFor(name);


        // Then
        Assert.assertEquals(expectedOutput, actualOutput);
    }

    @Test
    public void testRemove() {
        // Given
        PhoneBook phoneBook = new PhoneBook();
        String name = "Liam";
        String homeNumber = "211-111-2222";
        String cellNumber = "211-222-3333";
        ArrayList<String> phoneNumbers = new ArrayList<>();
        phoneNumbers.add(homeNumber);
        phoneNumbers.add(cellNumber);
        phoneBook.add(name, phoneNumbers);

        // When
        phoneBook.remove(name, homeNumber);

        // Then
        Assert.assertEquals(1, phoneBook.arrayListSize());
    }

    @Test
    public void testRemove2() {
        // Given
        PhoneBook phoneBook = new PhoneBook();
        String name = "Liam";
        String homeNumber = "211-111-2222";
        String cellNumber = "211-222-3333";
        ArrayList<String> phoneNumbers = new ArrayList<>();
        phoneNumbers.add(homeNumber);
        phoneNumbers.add(cellNumber);

        // When
        phoneBook.remove(name, homeNumber);

        // Then
        Assert.assertEquals(-1, phoneBook.arrayListSize());
    }

    @Test
    public void testRemoveRecord() {
        // Given
        PhoneBook phoneBook = new PhoneBook();
        String name = "Liam";
        String homeNumber = "211-111-2222";
        String cellNumber = "211-222-3333";
        ArrayList<String> phoneNumbers = new ArrayList<>();
        phoneNumbers.add(homeNumber);
        phoneNumbers.add(cellNumber);

        // When
        phoneBook.removeRecord(name);

        // Then
        Assert.assertEquals(0, phoneBook.size());
    }

    @Test
    public void testReverseLookup() {
        // Given
        PhoneBook phoneBook = new PhoneBook();
        String expectedOutput = "Caleb";
        String homeNumber = "211-111-2222";
        String cellNumber = "211-222-3333";
        ArrayList<String> phoneNumbers = new ArrayList<>();
        phoneNumbers.add(homeNumber);
        phoneNumbers.add(cellNumber);
        phoneBook.add(expectedOutput, phoneNumbers);

        // When
        String actualOutput = phoneBook.reverseLookUp(homeNumber);

        // Then
        Assert.assertEquals(expectedOutput, actualOutput);
    }

    @Test
    public void testListNamesAndNumbers() {
        // Given
        PhoneBook phoneBook = new PhoneBook();
        String name = "Liam";
        String homeNumber = "211-111-2222";
        String cellNumber = "211-222-3333";
        ArrayList<String> phoneNumbers = new ArrayList<>();
        phoneNumbers.add(homeNumber);
        phoneNumbers.add(cellNumber);
        phoneBook.add(name, phoneNumbers);

        String name2 = "Caleb";
        String homeNumber2 = "123-456-7890";
        String cellNumber2 = "123-111-2222";
        ArrayList<String> phoneNumbers2 = new ArrayList<>();
        phoneNumbers2.add(homeNumber2);
        phoneNumbers2.add(cellNumber2);
        phoneBook.add(name2, phoneNumbers2);

        String expectedOutput =  "Caleb [123-456-7890, 123-111-2222]" + "\n" + "Liam [211-111-2222, 211-222-3333]" + "\n";

        // When
        String actualOutput = phoneBook.listNamesAndNumbers();

        // Then
        Assert.assertEquals(expectedOutput, actualOutput);
    }
}
